appdir=addslash(convertchar(appdir,asc"/",asc"\"))
appfile=convertchar(appfile,asc"/",asc"\")

const key_esc%     =key_escape
const key_capslock%=20

const event_dropfile%=$4010
const event_dropdir%=$4011

global timer:ttimer2
function createtimer2:ttimer2(hertz#,event:tevent=null)
  return ttimer2.create(hertz,event)
endfunction
type ttimer2 extends ttimer
  field hz%
  function create:ttimer2(hertz#,event:tevent=null)
    local t:ttimer2=new ttimer2
    t._cycle=t
    t._event=event
    t._handle=bbtimerstart(hertz,t)
    t.hz=hertz
    return t
  endfunction
endtype

'-----------------------------------------

function countchar%(src$,ch%)
  local c%,sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=ch) then c:+1
  wend
  return c
endfunction
function countstr%(src$,ch$)
  local c%,sl%=1
  repeat
    local i%=instr(src,ch,sl)
    if not i then return c
    sl=i+1
    c:+1
  forever
endfunction

function convertchar$(src$,ch1%,ch2%)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=ch1) then src=src[..sl]+chr(ch2)+src[sl+1..]
  wend
  return src
endfunction

function convertstr$(src$,ch1$,ch2$)
  local cl1%=ch1.length
  if (cl1=0) then return src
  local pos%=src.length
  pos:-cl1
  while (pos>=0)
    local b%
    while (b<cl1)
      if (src[pos+b]<>ch1[b]) then exit
      b:+1
    wend
    if (b=cl1) then src=src[..pos]+ch2+src[pos+cl1..]
    pos:-1
  wend
  return src
endfunction

function charmul$(ch$,mul%)
  if not mul then return ""
  local a%=1
  while (a+a<mul)
    ch:+ch
    a:+a
  wend
  return ch+ch[..mul-a]
endfunction

function between$(src$,pos%=1,ch%=asc"\")
  local sl%
  local st%
  while (sl<src.length)
    if (src[sl]=ch) then
      pos:-1
      if (pos<=0) then return src[st..sl]'+1]
      st=sl+1
    endif
    sl:+1
  wend
'  if (pos=1) then return src[st..]
  return src[st..]
endfunction

function instrl%(src$,ch$,pos%=0)
  local cl%=ch.length
  if (cl=0) then return 0
  if (pos=0) then pos=src.length
  pos:-cl
  while (pos>=0)
    local p%
    while (p<cl)
      if (src[pos+p]<>ch[p]) then exit
      p:+1
    wend
    if (p=cl) then return pos+1
    pos:-1
  wend
endfunction

function delchars$(src$,ch$="\/:*?<>|"+chr(34))
  local sl%=src.length,cl%=ch.length-1
  while (sl>0)
    sl:-1
    local a%=cl,sc%=src[sl]
    while (a>=0)
      if (sc=ch[a]) then exit
      a:-1
    wend
    if (a>=0) then src=src[..sl]+src[sl+1..]
  wend
  return src
endfunction

function delead$(src$,ch%=asc" ")
  local a%,sl%=src.length
  while (a<sl) and (src[a]=ch)
    a:+1
  wend
  return src[a..]
endfunction
function delast$(src$,ch%=asc"\")
  local sl%=src.length-1
  while (sl>=0) and (src[sl]=ch)
    sl:-1
  wend
  return src[..sl+1]
endfunction
function deleast$(src$,ch%=asc" ")
  local a%,sl%=src.length
  while (a<sl) and (src[a]=ch)
    a:+1
  wend

  sl:-1
  while (sl>=0) and (src[sl]=ch)
    sl:-1
  wend
  return src[a..sl+1]
endfunction

function pointed$(src$,ch$=".",inter%=3)
  local p%=src.length
  repeat
    p:-inter
    if (p>0) then src=src[..p]+ch+src[p..] else return src
  forever
endfunction

'array.sort is faster if unsorted but case sensitive
'p2=length-1 (last entry)
function sortstr(array$[],p1%,p2%)
  if (p1>=p2) then return
  local eq%
  repeat
    eq=true
    local a%=p2
    repeat
      a:-1
      if (lower(array[a+1])<lower(array[a])) then
        local x$=array[a]
        array[a]=array[a+1]
        array[a+1]=x
        eq=false
      endif
    until (a=p1)
    p1:+1
  until (p1=p2) or eq
endfunction

'int("") is faster
function str2int%(src$)
  local ret%,a%,sl%=src.length,neg%=1
  while (a<sl)
    local sc%=src[a]
    if (sc=asc"-") then neg=-1
    a:+1
    sc:-asc"0"
    if (byte(sc)<10) then ret=(ret*10)+sc
  wend
  return ret*neg
endfunction

function float2str$(src#,commalen%=3)
  local ret$=src
  local p%=instr(ret,".")
  if (p>0) then return ret[..p+commalen-(commalen=0)]
  return ret
endfunction

'b=^n($1,$2,$4...)
function swapbit%(src%,b%)
  return (src&~b) + (b-(src&b))
endfunction

function hibit%(src%,ln%=32)
  local b%=1 shl (ln-1)
  repeat
    ln:-1
    if (src&b) then return ln
    b:shr 1
  until not ln
endfunction

function xor%(a%,b%)
  return (a&~b)|(~a&b)
endfunction

'-----------------------------------------

global actwin:twin=null
global deskw%=clientwidth (desktop())
global deskh%=clientheight(desktop())

function copygadget(grp:tgadget)
  gadgetcopy grp
  pollsystem
endfunction

function loadgfont(f:tstream,fnt:tguifont var)
  fnt.name=readstr(f)
  fnt.size=readpint(f)
  fnt.style=readpint(f)
  fnt=loadguifont(fnt.name,fnt.size)
endfunction
function savegfont(f:tstream,fnt:tguifont)
  writestr f,fnt.name
  writepint f,fnt.size
  writepint f,fnt.style
endfunction

function reqcolor%(r% var,g% var,b% var)
  if requestcolor(r,g,b) then
    r=requestedred()
    g=requestedgreen()
    b=requestedblue()
    return true
  endif
endfunction

function setlayout(g:tgadget,xw%,yh%,grp:tgadget,lft%=1,up%=1)
  local x2%,y2%
  if (xw=clientwidth (grp)) then x2=1
  if (yh=clientheight(grp)) then y2=1
'  if (xw=gadgetwidth (grp)) then x2=1
'  if (yh=gadgetheight(grp)) then y2=1
  setgadgetlayout g,lft,x2,up,y2
endfunction

function createlab:tgadget(name$,x%,y%,w%,h%,grp:tgadget,style%=0)
  local g:tgadget=createlabel(name,x,y,w,h,grp,style)
  setlayout g,x+w,y+h,grp
  return g
endfunction

'-----------------------------------------

function createwin:twin(name$,x%,y%,w%,h%,style%=15,grp:tgadget=null)
  local g:twin=new twin
  g.name=name
  g.x=x
  g.y=y
  g.w=w
  g.h=h
  g.maxsize
  g.outside
  g.hidden=(style&window_hidden>0)
  g.g=createwindow(name,x,y,w,h,grp,style)
  if not(style&window_hidden) or (actwin=null) then actwin=g
  g.cw=clientwidth (g.g)
  g.ch=clientheight(g.g)
'  g.cw=gadgetwidth (g.g)
'  g.ch=gadgetheight(g.g)
  return g
endfunction

type twin
  field g:tgadget
  field kid:tgadget=null
  field name$
  field x%,y%,w%,h%
  field cw%,ch%
  field dx%,dy%
  field hidden%',maximized%
  field drop$,droptyp%

  method load(f:tstream,dat%=false)
    x=readpint(f)
    y=readpint(f)
    w=readpint(f)
    h=readpint(f)
    maxsize
    outside
    if not dat then return
    name=readstr(f)
    setgadgettext g,name
  endmethod
  method save(f:tstream,dat%=false)
    writepint f,x
    writepint f,y
    writepint f,w
    writepint f,h
    if not dat then return
    writestr f,name
  endmethod

  method reset()
    setgadgetshape g,x,y,w,h
    cw=clientwidth (g)
    ch=clientheight(g)
  endmethod

  method activate()
    if (kid=null) then activategadget g else activategadget kid
  endmethod

  method show()
    hidden=0
    showgadget g
    if (kid<>null) then activategadget kid
    pollsystem
  endmethod
  method hide()
    hidden=1
    hidegadget g
    pollsystem
  endmethod

  method center()
    x=(deskw-w)/2
    y=(deskh-h)/2
  endmethod

  method maxsize()
    if (w>deskw) then w=deskw
    if (h>deskh) then h=deskh
  endmethod

  method inside()
    if (x+w>deskw) then x=deskw-w
    if (x<0)       then x=0
    if (y+h>deskh) then y=deskh-h
    if (y<0)       then y=0
  endmethod

  method outside()
    if (x>deskw-16) then x=deskw-16
    if (x+w<16)   then x=16-w
    if (y>deskh-20) then y=deskh-20
    if (y<-10)   then y=-10
  endmethod

  method upd%() 'return currentevent.id
    if (currentevent.source<>g) then return 0
    select currentevent.id
    case event_windowmove
      dx=currentevent.x-x
      dy=currentevent.y-y
      x=currentevent.x
      y=currentevent.y
      cw=clientwidth (g)
      ch=clientheight(g)
    case event_windowsize
      w=currentevent.x
      h=currentevent.y
      cw=clientwidth (g)
      ch=clientheight(g)
    case event_windowactivate
      actwin=self
'      if (kid<>null) then activategadget kid
    case event_windowaccept
      drop=string(currentevent.extra)
      droptyp=filetype(drop)
      if (droptyp=filetype_file) then
        drop=delast(drop)
        return event_dropfile
      endif
      return event_dropdir
    endselect
    return currentevent.id
  endmethod
endtype

'-----------------------------------------

function createmenue:tmenu(title$="",grp:tgadget=null,tg%=0,dis%=0,hkey%=0,mods%=0)
  local m:tmenu=new tmenu
  m.flag=m.flag[..1]
  m.flag[0]=tg shl 1
  m.g=m.g[..1]
  m.grp=grp
  m.g[0]=createmenu(title,tg,grp,hkey,mods)
  if dis then disablemenu m.g[0]
  return m
endfunction

type tmenu
  field g:tgadget[]
  field grp:tgadget
  field sub%
  field flag%[] 'bit0=checkable bit1>=tag

  method load(f:tstream)
    repeat
      local fl%=readpint(f)
      if fl=-1 then exit

      local fnd%=find(fl shr 1)
      if (fnd=-1) or (~flag[fnd]&$1) then
        f.skipbytes 1
      else
        flag[fnd]=(flag[fnd]&$fffffffe)|(fl&1)
        local b@=readbyte(f)
        if (b&$1) then checkmenu  g[fnd] else uncheckmenu g[fnd]
        if (b&$2) then enablemenu g[fnd] else disablemenu g[fnd]
      endif
    forever
    if (grp<>null) then updatewindowmenu grp
  endmethod
  method save(f:tstream)
    for local a%=0 until flag.length
      if flag[a]&$1 then
        writepint f,flag[a]
        writebyte f,menuchecked(g[a])+menuenabled(g[a]) shl 1
      endif
    next
    writepint f,-1
  endmethod

'flg bit0=checkable bit1=checked bit2=disabled
  method create(text$="",grp2:tgadget=null,tg%=0,flg%=0,hkey%=0,mods%=0)
    if not grp2 then grp2=grp
    sub=g.length
    g=g[..g.length+1]
    g[g.length-1]=createmenu(text,tg,grp2,hkey,mods)
    if (flg&2) then checkmenu   g[g.length-1]
    if (flg&4) then disablemenu g[g.length-1]
    flag=flag[..flag.length+1]
    flag[flag.length-1]=(flg&1)+(tg shl 1)
  endmethod

'flg bit0=checkable bit1=checked bit2=disabled
  method add(text$,tg%=0,flg%=0,hkey%=0,mods%=0)
    g=g[..g.length+1]
    g[g.length-1]=createmenu(text,tg,g[sub],hkey,mods)
    if (flg&2) then checkmenu   g[g.length-1]
    if (flg&4) then disablemenu g[g.length-1]
    flag=flag[..flag.length+1]
    flag[flag.length-1]=(flg&1)+(tg shl 1)
  endmethod

  method endadd()
    if (grp<>null) then updatewindowmenu grp
  endmethod

'  method gettext$(tg%)
'    for local a%=0 until flag.length
'      if (tg=flag[a] shr 1) then return menutext(g[a])
'    next
'  endmethod
  method settext(tg%,txt$)
    for local a%=0 until flag.length
      if (tg=flag[a] shr 1) then
        setmenutext g[a],txt
        return
      endif
    next
  endmethod

  method get%(tg%) 'return bit0=checked bit1=disabled
    for local a%=0 until flag.length
      if (tg=flag[a] shr 1) then return menuchecked(g[a])+((1-menuenabled(g[a])) shl 1)
    next
  endmethod
'flg bit0=checked bit1=disabled
  method set(tg%,flg%)
    for local a%=0 until flag.length
      if (tg=flag[a] shr 1) then
        if (flg&1) then checkmenu   g[a] else uncheckmenu g[a]
        if (flg&2) then disablemenu g[a] else enablemenu  g[a]
        if (grp<>null) then updatewindowmenu grp
        return
      endif
    next
  endmethod

  method popup(tg%,where:tgadget=null)
    if (where=null) then where=grp
    popupwindowmenu where,g[max(find(tg),0)]
  endmethod

  method find%(tg%) 'return nr or -1
    for local a%=0 until flag.length
      if (tg=flag[a] shr 1) then return a
    next
    return -1
  endmethod

  method upd%() '?same tags same check, return tag
    if (currentevent.id<>event_menuaction) then return 0
    for local a%=0 until flag.length
      if (currentevent.data=flag[a] shr 1) then
        if (flag[a]&1) then
          if menuchecked(g[a]) then uncheckmenu g[a] else checkmenu g[a]
          if (grp<>null) then updatewindowmenu grp
        endif
        return currentevent.data
      endif
    next
  endmethod
endtype

'-----------------------------------------

function createtab:ttab(x%,y%,w%,h%,grp:tgadget)
  local t:ttab=new ttab
  t.g=createtabber(x,y,w,h,grp)
  setlayout t.g,x+w,y+h,grp
  t.cw=clientwidth (t.g)
  t.ch=clientheight(t.g)
  return t
endfunction

type ttab
  field g:tgadget
  field t:tgadget[][]
  field cw%,ch%
  field on%,last%=-1,count%

  method load(f:tstream)
    activate min(readbyte(f),count-1)
  endmethod
  method save(f:tstream)
    writebyte f,on
  endmethod

  method activate(nr%=-1)
    last=on
    if (nr>=0) then if (nr>=t.length) then on=t.length-1 else on=nr
    for local a1%=0 until t.length
      for local a2%=0 until t[a1].length
        if (t[a1][a2]<>null) then hidegadget t[a1][a2]
      next
    next
    for local a2%=0 until t[on].length
      if (t[on][a2]<>null) then showgadget t[on][a2]
    next
    selectgadgetitem g,on
    if (t[on].length>0) then activategadget t[on][0]
  endmethod

  method add(text$,tip$="")
    addgadgetitem g,text,,,tip
    count:+1
    t=t[..count]
  endmethod

  method addkid(tab%,kid:tgadget)
    if not(kid=null) then hidegadget kid
    t[tab]=t[tab][..t[tab].length+1]
    t[tab][t[tab].length-1]=kid
  endmethod

  method upd%() 'return 1
    if (currentevent.source<>g)..
    or (currentevent.id<>event_gadgetaction) then return 0
    activate currentevent.data
    return 1
  endmethod
endtype

'-----------------------------------------

type tbut
  field g:tgadget[]
  field flag%[] 'bit0=checkbox bit1=disabled bit2>=tag

  method load(f:tstream)
    for local a%=0 until readpint(f)
      local flg%=readpint(f)
      for local b%=0 until g.length
        if (flg shr 2=flag[b] shr 2) then setbuttonstate g[b],flg&1
      next
    next
  endmethod
  method save(f:tstream)
    local l%
    for local a%=0 until g.length
      if (flag[a]&1) then l:+1
    next
    writepint f,l
    for local a%=0 until g.length
      if (flag[a]&1) then writepint f,buttonstate(g[a])+(flag[a]&$fffffffc)
    next
  endmethod

  method setstate(tg%,disable%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then
        flag[a]=(flag[a]&~2)+disable shl 1
        if disable then disablegadget g[a] else enablegadget g[a]
        return
      endif
    next
  endmethod

  method add(label$,tg%,x%,y%,w%,h%,grp:tgadget,sel%=0,style%=button_push,disable%=false)
    g=g[..g.length+1]
    g[g.length-1]=createbutton(label,x,y,w,h,grp,style)
    setlayout g[g.length-1],x+w,y+h,grp
    if sel then setbuttonstate g[g.length-1],1
    flag=flag[..flag.length+1]
    flag[flag.length-1]=((style=button_checkbox) or (style=button_radio))+(disable shl 1)+(tg shl 2)
    if disable then disablegadget g[g.length-1]
  endmethod

  method remove(tg%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then
        freegadget g[a]
        for local b%=a until g.length-1
          g[b]=g[b+1]
          flag[b]=flag[b+1]
        next
        g=g[..g.length-1]
        flag=flag[..flag.length-1]
        return
      endif
    next
  endmethod

  method get%(tg%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then return buttonstate(g[a])
    next
  endmethod
  method set(tg%,sel%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then
        setbuttonstate g[a],sel
        return
      endif
    next
  endmethod

  method find%(tg%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then return a
    next
  endmethod

  method upd%() 'return tag
    if (currentevent.id<>event_gadgetaction) then return 0
    for local a%=0 until g.length
      if (currentevent.source=g[a]) then return flag[a] shr 2
    next
  endmethod
endtype

'-----------------------------------------

function createpan:tpan(x%,y%,w%,h%,grp:tgadget,style%=0,r%=0,g%=128,b%=0)
  local p:tpan=new tpan
  p.col[0]=r
  p.col[1]=g
  p.col[2]=b
  p.x=x
  p.y=y
  p.g=createpanel(x,y,w,h,grp,xor(style,panel_active))
  setlayout p.g,x+w,y+h,grp
  setpanelcolor p.g,r,g,b
  return p
endfunction

type tpan
  field g:tgadget
  field col%[3]
  field x%,y%

  method load(f:tstream)
    col[0]=readbyte(f)
    col[1]=readbyte(f)
    col[2]=readbyte(f)
    setpanelcolor g,col[0],col[1],col[2]
  endmethod
  method save(f:tstream)
    writebyte f,col[0]
    writebyte f,col[1]
    writebyte f,col[2]
  endmethod

  method reset()
    setpanelcolor g,col[0],col[1],col[2]
  endmethod

  method upd%(req%=true) 'return 1 if mouseup
    if (currentevent.source<>g) then return 0
    select currentevent.id
    case event_mouseup
      if not req then return 1
      if not reqcolor(col[0],col[1],col[2]) then return 0
      setpanelcolor g,col[0],col[1],col[2]
      return 1
    endselect
  endmethod
endtype

'-----------------------------------------

'no way to get the data of an editable combobox
function createcombo:tcombo(x%,y%,w%,h%,grp:tgadget,style%=0)
  local c:tcombo=new tcombo
  c.g=createcombobox(x,y,w,h,grp,style)
  setlayout c.g,x+w,y+h,grp
  return c
endfunction

type tcombo
  field g:tgadget
  field count%
  field on%

  method load(f:tstream)
    on=readpint(f)
    if (on>=count) then on=0
    if count then selectgadgetitem g,on
  endmethod
  method save(f:tstream)
    writepint f,on
  endmethod

  method find%(t$)
    t=lower(t)
    for local a%=0 until count
      if t=lower(gadgetitemtext(g,a)) then return a
    next
    return -1
  endmethod

  method activatenr(nr%=-1)
    if (nr>=0) then on=nr
    selectgadgetitem g,on
  endmethod

  method sort()
    local s$[count]
    for local a%=0 until count
      s[a]=gadgetitemtext(g,a)
    next
    local o$=s[on]
    sortstr s,0,count-1
    for local a%=0 until count
      modifygadgetitem g,a,s[a]
      if (o=s[a]) then on=a
    next
  endmethod

  method get$(nr%=-1)
    if (nr<0) then nr=on
    if (nr>=count) then return ""
    return gadgetitemtext(g,nr)
  endmethod

  method add(text$)
    local t$=lower(text)
    addgadgetitem g,text
    on=count
    count:+1
    selectgadgetitem g,on
  endmethod

  method upd%()
    if (currentevent.id<>event_gadgetaction)..
    or (currentevent.source<>g) then return 0
    if (currentevent.data=-1) then return -1
    on=currentevent.data
    selectgadgetitem g,on
    return 1
  endmethod
rem
  method add(text$)
    if not(flag&8) and lmax and (count>=lmax) then return
    addgadgetitem g,text
    on=count
    count:+1
    activate
  endmethod

  method upd%()
    if (currentevent.id<>event_gadgetaction)..
    or (currentevent.source<>g) then return 0
    activate currentevent.data
    return 1
  endmethod
endrem
endtype

'-----------------------------------------

'style=$1=textfield_password $2=disable
function createfield:tfield(text$,x%,y%,w%,h%,grp:tgadget,style%=0)
  local f:tfield=new tfield
  f.g=createtextfield(x,y,w,h,grp,style&1)
  setlayout f.g,x+w,y+h,grp
  setgadgettext f.g,text
  f.state=(style&2) shr 1
  if f.state then disablegadget f.g
  return f
endfunction

type tfield
  field g:tgadget
  field state% '$1=disabled

  method load(f:tstream)
    setgadgettext g,readstr(f)
  endmethod
  method save(f:tstream)
    writestr f,textfieldtext(g)
  endmethod

  method get$()
    return textfieldtext(g)
  endmethod
  method set(s$)
    setgadgettext g,s
  endmethod

  method upd%()
    if (currentevent.id<>event_gadgetaction)..
    or (currentevent.source<>g) then return 0
    return 1
  endmethod
endtype

'-----------------------------------------
'~r ~n = new line(chr $10)
'~q    = "
'~~    = ~
'~t    = tab
'~0    = cut all behind

function createtext:ttext(x%,y%,w%,h%,grp:tgadget,style%=0)
  local t:ttext=new ttext
  t.flag=(style=textarea_readonly) shl 1
  t.g=createtextarea(x,y,w,h,grp,style)
  setlayout t.g,x+w,y+h,grp
  setgadgetfilter t.g,textfilter
  settextareacolor t.g,0,0,0,true
'  settextareacolor t.g,255,255,255,false
  formattextareatext t.g,255,255,25,0
  t.settabs 3
  return t
endfunction

function textfilter%(ev:tevent,context:object)
  select ev.id
  case event_keydown,event_keychar
    if (ev.mods&modifier_command) then return 1
    if not ev.mods or (ev.mods&modifier_shift) then
      select ev.data
      case key_left,key_right,key_down,key_up,key_pageup,key_pagedown..
      ,key_delete,key_backspace,key_home,key_end,key_esc,key_capslock return 1
      endselect
    endif
    if (ev.mods&(modifier_shift)) then
      select ev.data
      case key_insert  return 1
      endselect
    endif
  endselect
  postevent ev
endfunction

'select ttext.upd
'  case 1 tmenu.popup 0,win.g
'  case 2 ttext.updkey
type ttext
  field g:tgadget
  field tab%,flag% '$1=linesafe $2=readonly $4=insertmode
  field chars%,lines%
  field char%,line%,linestart%,lineend%,inline%
  field selchars%,sellines%
field lastcol%[3]'=[-1,-1,-1]
field lt$

  method load(f:tstream,data%=false)
    tab=readbyte(f)
    flag=readbyte(f)
    if not data then return
    settextareatext g,readstr(f)
    updpos
  endmethod
  method save(f:tstream,data%=false)
    writebyte f,tab
    writebyte f,flag
    if not data then return
    writestr f,textareatext(g)
  endmethod

  method loadtxt(f:tstream,ln%=-1)
    while ln and not eof(f)
      addtextareatext g,readline(f)
      ln:-1
    wend
    updpos
  endmethod

  method settabs(sz%)
    tab=sz
    settextareatabs g,sz
  endmethod

  method lock(hid%=0)
    locktextarea g
    showmouse
    if hid then hidegadget g
  endmethod
  method unlock(shw%=0)
    unlocktextarea g
    if shw then showgadget g
  endmethod

  method setfont(fnt:tguifont,locked%=true)
'    updpos
    if locked then lock
    local t$=textareatext(g)
    settextareatext g,""
    settextareafont g,fnt
    settextareatext g,t
    selecttextareatext g,char,selchars
    if locked then unlock
  endmethod

  method searchr%(s$,sl%=true)
'    s=lower(s)
    if (selchars=s.length) and (lower(textareatext(g,char,selchars))=s) then char:+s.length
    local p%=instr(lower(textareatext(g,char)),s)
    if (p=0) then
      p=instr(lower(textareatext(g,0,char+s.length-1)),s)
      if (p=0) then return 0
      char=0
    endif
    char:+p-1
    selchars=s.length
    if sl then selecttextareatext g,char,selchars
    return 1
  endmethod
  method searchl%(s$,sl%=true)
'    s=lower(s)
    local p%=instrl(lower(textareatext(g,0,char+s.length-1)),s)
    if (p=0) then
      p=instrl(lower(textareatext(g,char)),s)
      if (p=0) then return 0
      char:+p-1
    else
      char=p-1
    endif
    selchars=s.length
    if sl then selecttextareatext g,char,selchars
    return 1
  endmethod

  method getline$(l%=-1)
    if l<0 then l=line
    return delast(textareatext(g,l,1,textarea_lines),10)
  endmethod

  method set(t$)
    settextareatext g,t
    updpos
  endmethod

  method add(t$,col%[])
    addtextareatext g,t
    formattextareatext g,col[0],col[1],col[2],0,textarealen(g)-t.length,t.length
    updpos
  endmethod
  method add2start()
    lt=""
    lastcol=[-1,-1,-1]
  endmethod
  method add2(t$,col%[])
    if (col[0]<>lastcol[0]) or (col[1]<>lastcol[1]) or (col[2]<>lastcol[2]) then
      addtextareatext g,lt
      formattextareatext g,lastcol[0],lastcol[1],lastcol[2],0,textarealen(g)-lt.length,lt.length
      lastcol[0]=col[0]
      lastcol[1]=col[1]
      lastcol[2]=col[2]
      lt=""
    endif
    lt:+t
  endmethod
  method add2end()
    addtextareatext g,lt
    formattextareatext g,lastcol[0],lastcol[1],lastcol[2],0,textarealen(g)-lt.length,lt.length
    lt=""
    updpos
  endmethod

  method updpos()
    local olines%=lines+(lines=0),oline%=line
    local a%
    repeat
      chars=textarealen(g)
      lines=textarealen(g,textarea_lines)-(chars=0)

      char=textareacursor(g)
      line=textareacursor(g,textarea_lines)
      linestart=textareachar(g,line)
      lineend=textareachar(g,line+1)'-(line<lines-1)
      inline=char-linestart

      selchars=textareasellen(g)
'      sellines=textareasellen(g,textarea_lines)-(inline<>0)*(selchars=0)
      sellines=textarealine(g,char+selchars)-line

      if not(flag&$1) or (lines=olines) or a then return
      a:+1
      locktextarea g
      if lines>olines then
        if flag&$4 then
'          settextareatext g,"",textareachar(g,oline+1)-(oline=olines-1),textareachar(g,oline+1+lines-olines)-textareachar(g,oline+1)+(oline=olines-1)
          local lo%=lines-olines
          local olo%=oline+lo
          settextareatext g,"",textareachar(g,olo),textareachar(g,olo+lo)-textareachar(g,olo)
          settextareatext g,"",textareachar(g,olines)-(olines<textarealen(g,textarea_lines))
        else
          settextareatext g,"",textareachar(g,olines)-1..
        endif
      else
        addtextareatext g,charmul(chr(10),olines-lines)
      endif

      unlocktextarea g
      selecttextareatext g,char,0
    forever
  endmethod

  method upd%() 'return 1=gadgetmenu, 2=active
    if (currentevent.source<>g) then return 0
    select currentevent.id
    case event_gadgetmenu  return 1
    case event_gadgetselect  updpos
    endselect
    return 2
  endmethod

  method updkey()
    select currentevent.id
    case event_keydown
      select currentevent.data
      case key_insert  flag=swapbit(flag,$4)
      endselect

    case event_keychar
      settextareatext g,chr(currentevent.data),char,selchars+(flag&$4<>0)
      selecttextareatext g,char+1,0
      updpos
    endselect
  endmethod

  method pos2str$()
    return "chs:"+chars+" lns:"+lines..
     +" ch:"+char+" ln:"+line+" ls:"+linestart+" le:"+lineend+" inl:"+inline..
     +" selchs:"+selchars+" sellns:"+sellines
  endmethod
endtype

'-----------------------------------------

function readcomment$(f:tstream,linecom%=asc";")
  local t$
  repeat
    if eof(f) then return ""
    t=readline(f)
  until (t<>"") and (delead(t)[0]<>linecom)
  return t
endfunction

function gotohead%(f:tstream,what$,seek0%=true)
  if seek0 then f.seek 0
  what=lower(what)
  while not eof(f)
    local t$=deleast(readcomment(f))
    if (t[0]=asc"[") and (t[t.length-1]=asc"]")..
    and (lower(deleast(delchars(t,"[]")))=what) then return true
  wend
endfunction

function readstr$(f:tstream)
  return readstring(f,readpint(f))
endfunction
function writestr(f:tstream,s$)
  writepint f,s.length
  writestring f,s
endfunction

function readpint%(f:tstream)
  local ret%,a%,c%
  repeat
    a=readbyte(f)
    ret:+(a&$7f) shl c
    c:+7
  until not(a&$80)
  return ret
endfunction
function writepint(f:tstream,src%)
  repeat
    writebyte f,(src&$7f) + ((src shr 7<>0) shl 7)
    src:shr 7
  until not src
endfunction

function readstrarr(f:tstream,dst$[] var)
  local c%=readpint(f)
  dst=dst[..c]
  for local a%=0 until c
    dst[a]=readstring(f,readpint(f))
  next
endfunction
function writestrarr(f:tstream,src$[])
  writepint f,src.length
  for local a%=0 until src.length
    writepint f,src[a].length
    writestring f,src[a]
  next
endfunction

function addslash$(src$,sl%=asc"\")
  if src.length and (src[src.length-1]<>sl) then return src+chr(sl)
  return src
endfunction

'dst[] '0=byte 1=kb 2=mb 3=gb 4=tb...
function addfilesize(dst%[] var,src%)
  local a%
  while src
    if (dst.length<=a) then dst=dst[..a+1]
    dst[a]:+src&(1 shl 10-1)
    if (dst[a]>=1 shl 10) then
      if (dst.length<=a+1) then dst=dst[..a+2]
      dst[a+1]:+dst[a] shr 10
      dst[a]:&1 shl 10-1
    endif
    src:shr 10
    a:+1
  wend
endfunction
function filesize2str$(src%[])
  local szs$[]=[" Byte"," KB"," MB"," GB"," TB"," PB"," EB"," ZB"," ?B"]
  if src.length=1 then return src[0]+" Byte"..
  elseif not src.length then return "0 Byte"
  return src[src.length-1]+","+string(src[src.length-2]/1024.0)[2..4]+szs[min(src.length,szs.length)-1]
endfunction

function currentpath$()
  return addslash(convertchar(currentdir(),asc"/",asc"\"))
endfunction

function checkpath$(src$)
  src=trimpath(src)
  local c%
  repeat
    repeat
      src=delast(src)
      if (filetype(src)=filetype_dir) then return src+"\"
      src=trimpath(src)
    until (src="")
    src=currentpath()
    c:+1
  until (c=2)

  for c=asc"C" to asc"Z"
    if (filetype(chr(c)+":")=filetype_dir) then return chr(c)+":\"
  next

  if (filetype("B:")=filetype_dir) then return "B:\"
  if (filetype("A:")=filetype_dir) then return "A:\"
endfunction

function decpathr$(src$,dec%=1)
  local s%=instrl(src,"\")
  local e%=s
  while dec
    s=instrl(src,"\",s-1)
    if not s then exit
    dec:-1
  wend
  return src[..s]+src[e..]
endfunction

function instrfile%(url$,sub$)
  sub=trimfile(sub)
  local cs%=countchar(sub,asc".")+1
  if not cs then return 1
  url=trimfile(url)
  local cu%=countchar(url,asc".")+1
  local ps$=between(sub,cs,asc".")
  while cu
    if instr(between(url,cu,asc"."),ps) then
      cs:-1
      if not cs then return 1
      ps=between(sub,cs,asc".")
    endif
    cu:-1
  wend
endfunction
function instrpath%(url$,sub$)
  local cs%=countchar(sub,asc"\")
  if not cs then return 1
  local cu%=countchar(url,asc"\")
  local ps$=between(sub,cs)
  while cu
    if instr(between(url,cu),ps) then
      cs:-1
      if not cs then return 1
      ps=between(sub,cs)
    endif
    cu:-1
  wend
endfunction
'fileasis=false will find "i.x" in "file.txt"
function instrpfile%(url$,sub$,fileasis%=false)
  local cs%=countchar(sub,asc"\")
  local cu%
  if cs then
    cu=countchar(url,asc"\")
    local ps$=between(sub,cs)
    while cu
      if instr(between(url,cu),ps) then
        cs:-1
        if not cs then exit
        ps=between(sub,cs)
      endif
      cu:-1
    wend
    if not cu then return 0
  endif

  url=trimfile(url)
'  if not url then return 1
  sub=trimfile(sub)
  if fileasis then return instr(url,sub)
  cs=countchar(sub,asc".")+1
  cu=countchar(url,asc".")+1
  local ps$=between(sub,cs,asc".")
  while cu
    if instr(between(url,cu,asc"."),ps) then
      cs:-1
      if not cs then return 1
      ps=between(sub,cs,asc".")
    endif
    cu:-1
  wend
endfunction

'c:\path1.a\path2.b\file.test = c:\
function trimdrive$(src$,advanced%=false)
  local a%
  while (a<src.length)
    if (src[a]=asc":") then return addslash(src[..a+1])
    a:+1
  wend
  if not advanced then return ""
  src=currentpath()
  return trimdrive(src)
endfunction

'c:\path1.a\path2.b\file.test = c:\path1.a\path2.b\
function trimpath$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc"\") then return src[..sl+1]
  wend
  return src[..sl]
endfunction

'c:\path1.a\path2.b\file.test = file.test
function trimfile$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc"\") then return src[sl+1..]
  wend
  return src
endfunction

'c:\path1.a\path2.b\file.test = file
function trimname$(src$,hidext%=false)
  local sl1%=src.length
  local sl2%=sl1
  local l%=true
  while (sl1>0)
    sl1:-1
    if (l or hidext) and (src[sl1]=asc".") then
      sl2=sl1
      l=false
    endif
    if (src[sl1]=asc"\") then return src[sl1+1..sl2]
  wend
  return src[sl1..sl2]
endfunction

'c:\path1.a\path2.b\file.test = test
function trimext$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc".") then return src[sl+1..]
    if (src[sl]=asc"\") then return ""
  wend
endfunction

'c:\path1.a\path2.b\file.test = path1.a\path2.b\file.test
function trimpathr$(src$)
  if (src[0]=asc"\") then src=src[1..]
  local sl1%
  while (sl1<src.length) and (src[sl1]<>asc":")
    sl1:+1
  wend
  if (sl1>=src.length) then sl1=0..
  else sl1=min(sl1+2,src.length)
  return src[sl1..]
endfunction

'c:\path1.a\path2.b\file.test = path1.a\path2.b\
function trimpathm$(src$)
  if (src[0]=asc"\") then src=src[1..]
  local sl1%
  while (sl1<src.length) and (src[sl1]<>asc":")
    sl1:+1
  wend
  if (sl1>=src.length) then
    sl1=0
  else
    sl1=min(sl1+2,src.length)
  endif

  local sl2%=src.length-1
  while (sl2>=0) and (src[sl2]<>asc"\")
    sl2:-1
  wend
  sl2:+1
  if (sl2<0) then sl2=src.length
  return src[sl1..sl2]
endfunction

'-----------------------------------------

'tdir.reset "path",false
'while tdir.flag&$1
' print tdir.path+tdir.dir[0]+tdir.this
' if tdir.flags&$2 then dir
' tdir.upd
'wend
'tdir.close
type tdir
'public
  field path$
  field this$,dir$[] 'only 0 is important
  field flag% '$1=running $2=dir $4=dirchanged $8=sortdir
'private
  field rd%

'public
  method reset(p$,sortdir%=false)
    path=p
    dir=dir[..1]
    dir[0]=""
    rd=readdir(p)
    flag=(rd<>0)+sortdir shl 3
    if flag&1 then upd
  endmethod

  method close()
    if flag&1 then
      flag:&~1
      dir=dir[..0]
      closedir rd
    endif
  endmethod

  method skipdir%()
    closedir rd
    dir=dir[1..]
    if (dir.length=0) then
      flag:&~1
      return true
    endif
    if flag&8 then dir.sort
    rd=readdir(path+dir[0])
    if not rd then
      dir=dir[..0]
      flag:&~1
      return true
    endif
    flag:|4
  endmethod

  method upd()
    flag:&~(2+4)
    repeat
      repeat
        this=nextfile(rd)
      until (this<>".") and (this<>"..")

      if (this="") then
        if skipdir() then return
      else
        if (filetype(path+dir[0]+this)=filetype_dir) then
          flag:|2
          dir=dir[..dir.length+1]
          dir[dir.length-1]=dir[0]+this+"\"
        endif
        return
      endif
    forever
  endmethod
endtype

'-----------------------------------------
